﻿using T4UtilityBelt.Serializers;

namespace T4UtilityBelt.DataDesigns
{
    public class DateTimeProperty : EntityProperty
    {
        private const string RequiredType = "DateTime";

        private const string DefaultType = "DateTime?";

        public DateTimeProperty()
            : base(DefaultType)
        {
        }

        public DateTimeProperty(string name)
            : base(DefaultType, name)
        {
        }

        public DateTimeProperty(string name, bool required)
            : base(required ? RequiredType : DefaultType, name, required)
        {
        }

        public override UxDesigns.Control CreateControl()
        {
            // todo create a control for the DateTimeProperty
            return null;
        }

        [XIgnore()]
        public override bool IsPropertyTypeSpecified
        {
            get
            {
                return DefaultType != PropertyType;
            }
        }
    }
}