﻿using T4UtilityBelt.Serializers;

namespace T4UtilityBelt.DataDesigns
{
    public class DoubleProperty : EntityProperty
    {
        private const string RequiredType = "double";

        private const string DefaultType = "double?";

        public DoubleProperty()
            : base(DefaultType)
        {
        }

        public DoubleProperty(string name)
            : base(DefaultType, name)
        {
        }

        public DoubleProperty(string name, bool required)
            : base(required ? RequiredType : DefaultType, name, required)
        {
        }

        public override UxDesigns.Control CreateControl()
        {
            // todo create a control for the DoubleProperty
            return null;
        }

        [XIgnore]
        public override bool IsPropertyTypeSpecified
        {
            get
            {
                return DefaultType != PropertyType;
            }
        }
    }
}