﻿using T4UtilityBelt.Serializers;

namespace T4UtilityBelt.DataDesigns
{
    public class IntProperty : EntityProperty
    {
        private const string RequiredType = "int";

        private const string DefaultType = "int?";

        public IntProperty()
            : base(DefaultType)
        {
        }

        public IntProperty(string name)
            : base(DefaultType, name)
        {
        }

        public IntProperty(string name, bool required)
            : base(required ? RequiredType : DefaultType, name, required)
        {
        }

        public override UxDesigns.Control CreateControl()
        {
            // todo create a control for the IntProperty
            return null;
        }

        [XIgnore]
        public override bool IsPropertyTypeSpecified
        {
            get
            {
                return DefaultType != PropertyType;
            }
        }
    }
}