﻿// ***********************************************************************
// Assembly         : T4UtilityBelt
// Author           : Daan Jonkers
// Created          : 01-05-2013
//
// Last Modified By : Daan Jonkers
// Last Modified On : 01-05-2013
// ***********************************************************************
// <copyright file="SerializerException.cs" company="">
//     Copyright (c) . All rights reserved.
// </copyright>
// <summary></summary>
// ***********************************************************************
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace T4UtilityBelt.Serializers
{
    /// <summary>
    /// Class SerializerException
    /// </summary>
    [Serializable]
    public class SerializerException : Exception
    {
        protected SerializerException(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SerializerException" /> class.
        /// </summary>
        public SerializerException()
        {
            
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SerializerException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        public SerializerException(string message) : base(message)
        {

        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SerializerException" /> class.
        /// </summary>
        /// <param name="message">The message.</param>
        /// <param name="innerException">The inner exception.</param>
        public SerializerException(string message, Exception innerException)
            : base(message, innerException)
        {

        }

    }
}
