﻿using System.Collections.Generic;
using T4UtilityBelt.UxDesigns.Controls.Renderers;

using T4UtilityBelt.Writers;

namespace T4UtilityBelt.UxDesigns.Controls
{
    public class GridColumn : ContentElement<GridColumn, IGridColumnRenderer>
    {
        public GridColumn()
        {
        }

        public GridLength Width { get; set; }

        public double? MaxWidth { get; set; }

        public double? MinWidth { get; set; }

        public int? GridColumnNr { get; set; }

        private ControlCollection _controls;
        public ControlCollection Controls
        {
            get { return _controls ?? (_controls = new ControlCollection()); }
            //set { _controls = value; }
        }

        public bool HasControls
        {
            get
            {
                return _controls != null;
            }
        }

        public virtual IEnumerable<Control> AllControls()
        {
            if (HasControls)
            {
                foreach (var c in Controls)
                {
                    yield return c;
                    foreach (Control cc in c.AllControls())
                    {
                        yield return cc;
                    }
                }
            }
        }

        public override void FixModel(DataDesigns.Entity entity)
        {
            if (HasControls)
            {
                foreach (Control control in Controls)
                {
                    control.FixModel(entity);
                }
            }
        }

        public void RenderGridColumnDefinition(CodeWriter writer)
        {
            this.CreateControlRenderer(writer.Platform).RenderGridColumnDefinition(this, writer);
        }
    }
}