﻿using T4UtilityBelt.UxDesigns.Controls.Renderers.Android.Helpers;
using T4UtilityBelt.Writers;

namespace T4UtilityBelt.UxDesigns.Controls.Renderers.Android
{
    public class ItemTemplateRenderer : ControlRenderer<ItemTemplateControl, IItemTemplateRenderer>, IItemTemplateRenderer
    {
        protected override void OnRenderUiXmlBegin(ItemTemplateControl control, CodeWriter writer)
        {
            writer.WriteBeginTag("LinearLayout");
            RenderFirstElementAttributes(writer);
            RenderControlAttributes(control, writer);
            OrientationWriter.Write(Orientation.Vertical, writer);
            writer.WriteEnd();
        }

        protected override void OnRenderUiXmlContent(ItemTemplateControl control, CodeWriter writer)
        {
            control.Controls.RenderUiXml(writer);
        }

        protected override void OnRenderUiXmlEnd(ItemTemplateControl control, CodeWriter writer)
        {
            writer.WriteEndTag("LinearLayout");
        }
    }
}