﻿using T4UtilityBelt.DataDesigns;
using T4UtilityBelt.Writers;

namespace T4UtilityBelt.UxDesigns.Controls.Renderers.ViewModel
{
    [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1005:AvoidExcessiveParametersOnGenericTypes")]
    public abstract class PropertyRenderer<TControl, TRenderer, TProperty> : Renderer<TControl, TRenderer>, IPropertyRenderer<TControl, TRenderer, TProperty> 
        where TControl : PropertyControl<TControl, TRenderer, TProperty>
        where TRenderer : class, IPropertyRenderer<TControl, TRenderer, TProperty>
        where TProperty : Property
    {
        protected override void OnRenderUiXmlBegin(TControl control, CodeWriter writer)
        {
        }

        protected abstract void OnRenderUiXmlContentReadOnly(TControl control, CodeWriter writer);

        protected abstract void OnRenderUiXmlContentInput(TControl control, CodeWriter writer);

        protected override void OnRenderUiXmlEnd(TControl control, CodeWriter writer)
        {
        }
    }
}