﻿using T4UtilityBelt.Writers;

namespace T4UtilityBelt.UxDesigns.Controls.Renderers.Windows
{
    public class ButtonRenderer : ControlRenderer<ButtonControl, IButtonRenderer>, IButtonRenderer
    {
        // <Button Content="Go!" Command="{Binding SearchCommand}"></Button>
        protected override void OnRenderUiXmlBegin(ButtonControl control, CodeWriter writer)
        {
            writer.WriteBeginTag("Button");
            RenderControlAttributes(control, writer);
            writer.AddBinding("Command", control.Click);
            //writer.WriteAttributeFormat("Command", @"{{Binding {0}}}", control.CommandName);
            writer.WriteEnd();
        }

        protected override void OnRenderUiXmlContent(ButtonControl control, CodeWriter writer)
        {
            LabelControl label = new LabelControl() { Text = control.Text };
            label.RenderUiXml(writer);
            //control.Controls.RenderUiXml(writer);
        }

        protected override void OnRenderUiXmlEnd(ButtonControl control, CodeWriter writer)
        {
            writer.WriteEndTag("Button");
        }

        protected override void OnRenderViewModelCs(ButtonControl control, CodeWriter writer)
        {
//            writer.WriteFormatLine(
//@"      public ICommand {0}Command
//        {{
//            get
//            {{
//                return new MvxRelayCommand(Execute{0});
//            }}
//        }}
// 
//        public Partial void Execute{0}();
//",
//control.CommandName
//);

        }
    }
}