﻿using System.ComponentModel;
using T4UtilityBelt.UxDesigns.Bindings;
using T4UtilityBelt.UxDesigns.Controls;
using T4UtilityBelt.UxDesigns.Screens2.Renders;
using T4UtilityBelt.UxDesigns.Specialized;

namespace T4UtilityBelt.UxDesigns.Screens2
{
    [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Maintainability", "CA1501:AvoidExcessiveInheritance")]
    public class EntityUpdateScreen : ContentEntityScreen<EntityUpdateScreen, IEntityUpdateScreenRenderer>
    {
        public EntityUpdateScreen()
        {
            StandardConstructor();
        }

        public EntityUpdateScreen(string entityName)
            : base(entityName)
        {
            StandardConstructor();
        }

        public EntityUpdateScreen(string entityName, string screenName)
            : base(entityName, screenName)
        {
            StandardConstructor();
        }

        private void StandardConstructor()
        {
            ActionBar.Controls.Add(new ActionButton() { Click = new Binding("SaveCommand"), Text = "Save", IconUri = "Save", ShouldSerialize = false });
            ActionBar.Controls.Add(new ActionButton() { Click = new Binding("DeleteCommand"), Text = "Delete", IconUri = "Delete", ShouldSerialize = false });
        }
    }
}