﻿using T4UtilityBelt.Writers;

namespace T4UtilityBelt.UxDesigns.Screens2.Renders.Windows
{
    public class EntityUpdateScreenRenderer : IEntityUpdateScreenRenderer
    {
        public void RenderParentClass(EntityUpdateScreen control, CodeWriter writer)
        {
            //writer.Write(string.Format("UpdateEntityViewModel<{0}Model, {0}Entity>", control.EntityName));
        }


        public void RenderCode(EntityUpdateScreen control, CodeWriter writer)
        {
            writer.Write(string.Format(@"
        public {0}UpdateEntityView()
        {{
            InitializeComponent();
        }}

        public new {0}UpdateEntityViewModel ViewModel
        {{
            get {{ return base.ViewModel as {0}UpdateEntityViewModel; }}
            set {{ base.ViewModel = value; }}
        }}
", control.EntityName));
        }

        public void RenderControls(EntityUpdateScreen control, CodeWriter writer)
        {
            writer.WriteFullTag("Grid");
            writer.WriteFullTag("phone:Pivot");

            control.Header.RenderUiXmlBegin(writer);

            control.Content.RenderUiXml(writer);

            control.Header.RenderUiXmlEnd(writer);

            writer.WriteEndTag("phone:Pivot");

            control.ActionBar.RenderUiXml(writer);
            writer.WriteEndTag("Grid");
        }
    }
}
