﻿using T4UtilityBelt.UxDesigns.Screens;
using T4UtilityBelt.Writers;

namespace T4UtilityBelt.UxDesigns.Specialized.Renderers.WindowsPhone
{
    public class BaseScreenRenderer : IBaseScreenRenderer
    {
        public void RenderParentClass(BaseScreen control, CodeWriter writer)
        {
            //writer.Write(string.Format("CreateEntityViewModel<{0}Model, {0}Entity>", control.EntityName));
        }


        public void RenderCode(BaseScreen control, CodeWriter writer)
        {
            writer.Write(string.Format(@"
        public {0}ScreenView()
        {{
            InitializeComponent();
        }}

        public new {0}CreateEntityViewModel ViewModel
        {{
            get {{ return base.ViewModel as {0}CreateEntityViewModel; }}
            set {{ base.ViewModel = value; }}
        }}
", control.EntityName));
        }

        public void RenderControls(BaseScreen control, CodeWriter writer)
        {
            writer.WriteFullTag("Grid");
            writer.WriteFullTag("phone:Pivot");

            control.Header.RenderUiXmlBegin(writer);

            control.Content.RenderUiXml(writer);

            control.Header.RenderUiXmlEnd(writer);

            writer.WriteEndTag("phone:Pivot");

            control.ActionBar.RenderUiXml(writer);
            writer.WriteEndTag("Grid");
        }

    }
}
