﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace T4UtilityBelt.UxDesigns
{
    public struct FontStyle
    {
        private FontStyleType _style;

        internal FontStyleType Style
        {
            get
            {
                return this._style;
            }
        }

        //internal FontStyle(FontStyleType style)
        //{
        //    this._style = style;
        //}

        public override bool Equals(object obj)
        {
            if (obj is FontStyle)
            {
                return this == (FontStyle)obj;
            }
            else
            {
                return false;
            }
        }

        public override int GetHashCode()
        {
            return (int) this.Style;
        }

        public static bool operator ==(FontStyle left, FontStyle right)
        {
            return left._style == right._style;
        }

        public static bool operator !=(FontStyle left, FontStyle right)
        {
            return !(left == right);
        }

        public override string ToString()
        {
            string str = "Normal";
            FontStyleType fontStyleType = this._style;
            switch (fontStyleType)
            {
                case FontStyleType.Normal:
                    {
                        str = "Normal";
                        return str;
                    }
                case FontStyleType.Oblique:
                    {
                        return str;
                    }
                case FontStyleType.Italic:
                    {
                        str = "Italic";
                        return str;
                    }
                default:
                    {
                        return str;
                    }
            }
        }
    }
}
